// Generated by CoffeeScript 1.9.0
var debug, getChanges, objectify, parseZmqMessage, _;

_ = require('lodash');

debug = require("debug")("omg-class_node_producer:helpers");

parseZmqMessage = function() {
  var data, e, msg;
  msg = [];
  Array.prototype.slice.call(arguments).forEach((function(_this) {
    return function(arg) {
      return msg.push(arg.toString());
    };
  })(this));
  data = msg[3];
  if (data) {
    try {
      data = JSON.parse(data);
      msg[3] = data;
    } catch (_error) {
      e = _error;
      debug(e);
    }
  }
  return msg;
};

objectify = function(object) {
  var ind, item, newObject, _i, _len;
  if (_.isString(object)) {
    newObject = object;
  } else if (_.isArray(object)) {
    newObject = {};
    for (ind = _i = 0, _len = object.length; _i < _len; ind = ++_i) {
      item = object[ind];
      newObject[ind] = objectify(item);
    }
  } else if (_.isPlainObject(object)) {
    newObject = {};
    for (ind in object) {
      item = object[ind];
      newObject[ind] = objectify(item);
    }
  } else {
    newObject = object;
  }
  return newObject;
};

getChanges = function(prev, now) {
  var changes, nowProp, preProp, prop, subChanges;
  changes = {};
  for (prop in now) {
    if (!prev) {
      return changes = now;
    }
    preProp = prev[prop];
    nowProp = now[prop];
    if (!preProp || (preProp !== nowProp)) {
      if (_.isObject(nowProp)) {
        if (_.isEmpty(nowProp)) {
          changes[prop] = nowProp;
        } else {
          subChanges = getChanges(preProp, nowProp);
          if (subChanges) {
            changes[prop] = subChanges;
          }
        }
      } else if (_.isString(nowProp)) {
        if (nowProp && !preProp) {
          changes[prop] = nowProp;
        }
        if (preProp !== nowProp) {
          changes[prop] = nowProp;
        }
      } else if (_.isNumber(nowProp)) {
        if (preProp !== nowProp) {
          changes[prop] = nowProp;
        }
      } else if (_.isBoolean(nowProp)) {
        if (nowProp === false) {
          if (!(preProp === void 0 || preProp === false)) {
            changes[prop] = false;
          }
        }
        if (nowProp === true) {
          if (preProp !== true) {
            changes[prop] = true;
          }
        }
      }
    }
  }
  if (_.isEmpty(changes)) {
    changes = void 0;
  }
  return changes;
};

module.exports = {
  getChanges: getChanges,
  objectify: objectify,
  parseZmqMessage: parseZmqMessage
};
