// Generated by CoffeeScript 1.9.0
var Cpuload, Producer, cpu, debug, isRunning, os, _,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

Producer = require('class_node_producer');

os = require("os");

debug = require("debug")("omg-cpuload");

isRunning = false;

Cpuload = (function(_super) {
  __extends(Cpuload, _super);

  function Cpuload() {
    var run, runInterval;
    Cpuload.__super__.constructor.call(this, "cpuload", 15000);
    run = (function(_this) {
      return function() {
        var getNew, old, timeout;
        timeout = 1;
        old = _.map(os.cpus(), function(cpu) {
          return cpu.times;
        });
        getNew = function() {
          var current, result;
          result = [];
          current = _.map(os.cpus(), function(cpu) {
            return cpu.times;
          });
          _.each(current, function(item, cpuKey) {
            var oldVal;
            result[cpuKey] = {};
            oldVal = old[cpuKey];
            return _.each(_.keys(item), function(timeKey) {
              var diff, name;
              diff = parseFloat(item[timeKey] - parseFloat(oldVal[timeKey])) / parseFloat(timeout * 100);
              name = timeKey;
              if (timeKey === "idle") {
                name = "CPU";
                diff = 100 - diff;
              }
              return result[cpuKey][name] = diff.toFixed(0);
            });
          });
          old = current;
          debug("sending cpu");
          return _this.sendData(result);
        };
        return setTimeout(getNew, 1000);
      };
    })(this);
    runInterval = false;
    this.start = (function(_this) {
      return function() {
        if (runInterval) {
          clearInterval(runInterval);
        }
        return runInterval = setInterval(run, 1000);
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        isRunning = false;
        if (runInterval) {
          return clearInterval(runInterval);
        }
      };
    })(this);
  }

  Cpuload.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return Cpuload.__super__.subscribe.apply(this, arguments);
  };

  return Cpuload;

})(Producer);

cpu = new Cpuload();

cpu.subscribe();

module.exports = cpu;
