'use strict';

module.exports = function(grunt) {

// Project configuration.
grunt.initConfig({
  mochacli: {
    options: {
      require: ['should'],
      reporter: 'nyan',
      bail: true,
      harmony: true
    },
    all: ['test/*.js']
  },
  jshint: {
    options: {
      jshintrc: '.jshintrc'
    },
    gruntfile: {
      src: 'Gruntfile.js'
    },
    lib: {
      src: ['lib/**/*.js']
    },
    test: {
      src: ['test/**/*.js']
    },
  },
  watch: {
    gruntfile: {
      files: '<%= jshint.gruntfile.src %>',
      tasks: ['jshint:gruntfile']
    },
    lib: {
      files: '<%= jshint.lib.src %>',
      tasks: ['mochacli']
    },
    test: {
      files: '<%= jshint.test.src %>',
      tasks: ['mochacli']
    },
  },
});

// These plugins provide necessary tasks.

grunt.registerTask('test', ['mochacli']);
grunt.loadNpmTasks('grunt-mocha-cli');
grunt.loadNpmTasks('grunt-contrib-jshint');
grunt.loadNpmTasks('grunt-contrib-watch');

// Default task.
grunt.registerTask('default', ['jshint', 'mochacli']);

};