// Generated by CoffeeScript 1.9.0
"use strict";
var omg_testcall, _;

global.appConfig = {
  agg: {
    address: "127.0.0.1",
    subscriberPoolPort: 9008,
    pubSub: 9009,
    reqRep: 9010,
    protocol: "tcp"
  },
  server: {
    port: 8080,
    logLevel: "warn",
    binPath: "webApp/bin"
  },
  logger: {
    verbose: false,
    logLevel: "warn",
    logFilePath: false
  },
  environment: "prod",
  sudo: false
};

omg_testcall = require("../lib/omg-testcall.js");

_ = require("lodash");

describe("omg_testcall", function() {
  var protocols;
  protocols = ["TCP"];
  it("should call Johannes', but cancel the call", function(done) {
    var callObject, gotOutput, outputCallback, startCallback, stopIt, wasStarted;
    this.timeout(10000);
    callObject = {
      calledPartyNumber: "omg/1/M1:O2/+4917621019096",
      callingPartyNumber: "n1:o2/+492134567890",
      channel: 1,
      host: "127.0.0.1",
      localAddress: "127.0.0.1",
      localMediaAddres: "127.0.0.1",
      port: "5060",
      proto: "tcp",
      redirectedNumber: "g1:G2/1298765432",
      type: "isdn",
      callerName: "johannes"
    };
    wasStarted = void 0;
    gotOutput = 0;
    startCallback = function(err) {
      if (err) {
        throw err;
      }
      wasStarted = true;
      if (gotOutput > 10) {
        done();
      }
    };
    stopIt = function() {
      return omg_testcall.stop(function(err) {
        console.log(err);
        done();
      });
    };
    outputCallback = function(err, res) {
      if (err === "regular stop") {
        console.log("regular stop with code " + res);
        done();
      }
      if (err && (err !== "regular stop")) {
        console.warn(JSON.stringify(err));
      }
      console.warn(res);
      if (res) {
        gotOutput++;
      }
    };
    omg_testcall.start(callObject, startCallback, outputCallback);
    return setTimeout(stopIt, 40000);
  });

  /* setting a break here, remove this soon! */
  if (true) {
    return;
  }
  _.each(protocols, function(proto) {
    it("should call Johannes' cellphone and return a code. Protocol: " + proto, function(done) {
      var callObject, gotOutput, outputCallback, startCallback, wasStarted;
      this.timeout(10000);
      callObject = {
        host: "10.1.1.13",
        port: "5060",
        proto: proto,
        calledPartyNumber: "+4917621019096",
        callingPartyNumber: "+493328455123"
      };
      wasStarted = void 0;
      gotOutput = 0;
      startCallback = function(err, res) {
        if (err) {
          throw err;
        }
        wasStarted = true;
        console.log("startCallback" + res);
        if (gotOutput > 10) {
          done();
        }
      };
      outputCallback = function(err, res) {
        if (err === "regular stop") {
          done();
        }
        if (err && (err !== "regular stop")) {
          console.warn(JSON.stringify(err));
        }
        if (res) {
          gotOutput++;
        }
      };
      omg_testcall.start(callObject, startCallback, outputCallback);
    });
  });
});
