zmq = require 'zmq'
fs = require 'fs'
z85 = require 'z85'

child_process = require 'child_process'
debug = require("debug")("omg-webui:producerConnection")

try
  serverPublicKey = fs.readFileSync "/data/curvekeys/serverPublic"
  producerPublicKey = fs.readFileSync "/data/curvekeys/producerPublic"
  producerPrivateKey = fs.readFileSync "/data/curvekeys/producerPrivate"
catch e
  child_process.execSync "omgcurvekeygen"
  serverPublicKey = fs.readFileSync("/data/curvekeys/serverPublic")
  producerPublicKey = fs.readFileSync "/data/curvekeys/producerPublic"
  producerPrivateKey = fs.readFileSync "/data/curvekeys/producerPrivate"

serverPublicKey = serverPublicKey.toString()
producerPublicKey = producerPublicKey.toString()
producerPrivateKey = producerPrivateKey.toString()

configloader = require 'omg-configloader'
config = configloader.zmq
{standardAddress, standardTransport, reqrepbroker, pushpullbroker, pubsubbroker} = config

repPort = ->
  transport = reqrepbroker.transport or standardTransport
  address = reqrepbroker.address or standardAddress
  port = reqrepbroker.rep
  return "#{transport}://#{address}:#{port}"

ReqSocket = ->
  reqSocket = zmq.socket "dealer"
  reqSocket.curve_publickey = producerPublicKey
  reqSocket.curve_secretkey = producerPrivateKey
  reqSocket.curve_serverkey = serverPublicKey
  #set higher maximum listeners
  reqSocket.setMaxListeners(40)
  reqSocket.connect repPort()
  return reqSocket

subPort = ->
  transport = pubsubbroker.transport or standardTransport
  address = pubsubbroker.address or standardAddress
  port = pubsubbroker.pub
  return "#{transport}://#{address}:#{port}"

subSocket = zmq.socket('sub')
subSocket.curve_publickey = producerPublicKey
subSocket.curve_secretkey = producerPrivateKey
subSocket.curve_serverkey = serverPublicKey
subSocket.connect subPort()

pushPort = ->
  transport = pushpullbroker.transport or standardTransport
  address = pushpullbroker.address or standardAddress
  port = pushpullbroker.pull
  return "#{transport}://#{address}:#{port}"
pushSocket = zmq.socket "push"
pushSocket.curve_publickey = producerPublicKey
pushSocket.curve_secretkey = producerPrivateKey
pushSocket.curve_serverkey = serverPublicKey
pushSocket.connect pushPort()

exports.pushSocket = pushSocket
exports.subSocket = subSocket
exports.ReqSocket = ReqSocket
