zmq = require("zmq")
debug = require("debug")("omg-broker:pushpull")
chalk = require 'chalk'
sockets = require 'omg-zmqsockets'
child_process = require 'child_process'
fs = require 'fs'

try
  serverPrivateKey = fs.readFileSync "/data/curvekeys/serverPrivate"
catch e
  child_process.execSync "omgcurvekeygen"
  serverPrivateKey = fs.readFileSync("/data/curvekeys/serverPrivate")
serverPrivateKey = serverPrivateKey.toString()


logError = (e) ->
  debug chalk.red.bold(e)

configloader = require 'omg-configloader'
config = configloader.zmq
{standardAddress, standardTransport, pushpullbroker} = config

transport = pushpullbroker.transport or standardTransport
address = pushpullbroker.address or standardAddress
port = pushpullbroker.pull
pullPort = "#{transport}://#{address}:#{port}"
pullSocket = zmq.socket "pull"
pullSocket.curve_server = 1
pullSocket.curve_secretkey = serverPrivateKey
pullSocket.bindSync pullPort

# pushPort = "#{transport}://#{address}:#{pushpullbroker.push}"
# pushSocket = zmq.socket "push"
# pushSocket.bindSync pushPort


producerSockets = {}

pullSocket.on "message", (msg) ->
  args = Array.apply(null, arguments)
  producerName = args[0].toString()

  if producerSockets[producerName]
    # debug "forwarding data to #{producerName}: #{args[1]}"
    producerSockets[producerName].send args
  else
    sockets.create producerName, 'push', (socket)->
      # debug "forwarding data to new #{producerName}: #{args[1]}"
      producerSockets[producerName] = socket
      socket.send args


# tempPush = ->
#   counter = 0
#   pushSocket = zmq.socket "push"
#   pushSocket.connect pullPort
#   sendsomething = ->
#     counter++
#     pushSocket.send ["hu", counter, "threee"]
#     pushSocket.send ["hu", counter, "threee"]
#     pushSocket.send ["hu", counter, "threee"]
#     pushSocket.send ["hu", counter, "threee"]
#     pushSocket.send ["hu", counter, "threee"]
#   setInterval sendsomething, 1000
# setTimeout tempPush, 100

