zmq = require("zmq")
chalk = require 'chalk'
child_process = require 'child_process'
fs = require 'fs'

debug = require("debug")("omg-broker:reqrep")

sockets = require 'omg-zmqsockets'

try
  serverPrivateKey = fs.readFileSync "/data/curvekeys/serverPrivate"
catch e
  child_process.execSync "omgcurvekeygen"
  serverPrivateKey = fs.readFileSync("/data/curvekeys/serverPrivate")
serverPrivateKey = serverPrivateKey.toString()


logError = (e) ->
  debug chalk.red.bold(e)

configloader = require 'omg-configloader'
config = configloader.zmq
{standardAddress, standardTransport, reqrepbroker} = config

transport = reqrepbroker.transport or standardTransport
address = reqrepbroker.address or standardAddress
port = reqrepbroker.rep
repPort = "#{transport}://#{address}:#{port}"
frontend = zmq.socket "router"

frontend.curve_server = 1
frontend.curve_secretkey = serverPrivateKey
frontend.bindSync repPort

producerSockets = {}

frontend.on "message", (msg) ->
  args = Array.apply(null, arguments)
  producerName = args[2].toString()

  if producerSockets[producerName]
    debug "forwarding data to #{producerName}"
    producerSockets[producerName].send args
  else
    sockets.create producerName, 'dealer', (socket)->
      unless producerSockets[producerName]
        debug "created new socket for #{producerName}"

        #save reference to new socket
        producerSockets[producerName] = socket

        #register callback that sends data from producer to frontend
        socket.on "message", (msg) ->
          args = Array.apply(null, arguments)
          frontend.send args

      # forward arguments to producer
      socket.send args
